package jp.sf.amateras.xmleditor.editors;

import jp.sf.amateras.xmleditor.preferences.PreferenceConstants;

import org.eclipse.jface.text.rules.*;
import org.eclipse.jface.text.*;

public class XMLScanner extends RuleBasedScanner {
	
	private ColorManager manager;
	
	public XMLScanner(ColorManager manager) {
		this.manager = manager;
		initialize();
	}
	
	public void initialize(){
		setDefaultReturnToken(
				new Token(
					new TextAttribute(
						manager.getColor(PreferenceConstants.COLOR_DEFAULT))));
		
		IToken procInstr =
			new Token(
				new TextAttribute(
					manager.getColor(PreferenceConstants.COLOR_PROC)));

		IRule[] rules = new IRule[2];
		//Add rule for processing instructions
		rules[0] = new SingleLineRule("<?", "?>", procInstr);
		// Add generic whitespace rule.
		rules[1] = new WhitespaceRule(new XMLWhitespaceDetector());
		
		setRules(rules);
	}
	
}
